//+------------------------------------------------------------------+
//|                                                 VZO.mq4 |
//|                               Copyright  2012, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_minimum -100
#property indicator_maximum 100

#property indicator_buffers 1
#property indicator_color1 Blue 



extern int Period1=12;
extern double OB=50;
extern double OS=-50; 
extern double smooth = 5;

double VZO[];
double VPA[];
double VA[];
double VP[];
double VOL[];
int init()
  {
  
    IndicatorBuffers(5);
	
   IndicatorShortName("VZO");
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_LINE);
   
   SetIndexBuffer(0,VZO);  
   SetIndexBuffer(1,VPA);
   SetIndexBuffer(2,VA);
   SetIndexBuffer(3,VP);   
   SetIndexBuffer(4,VOL);
   
   
      int windowIndex=WindowFind("VZO");
   // finding the window number of our indicator
   
   if(windowIndex<0)
   {
      // if the number is -1, there is an error
      Print("Can\'t find window");
      return(0);
   }  
 
   ObjectCreate("OB",OBJ_HLINE,windowIndex,0,OB);
   ObjectCreate("OS",OBJ_HLINE,windowIndex,0,OS);
   // drawing a line in the indicator subwindow
               
   ObjectSet("OB",OBJPROP_COLOR,Black);
   ObjectSet("OB",OBJPROP_WIDTH,3);
   
    ObjectSet("OS",OBJPROP_COLOR,Black);
   ObjectSet("OS",OBJPROP_WIDTH,3);
 
   WindowRedraw();      
   // redraw the window to see the line
   
   
   return(0);
  }

int deinit()
  {
  
   ObjectsDeleteAll();
   // delete all objects
  
  
   return(0);
  }

int start()
 {
     int ExtCountedBars=IndicatorCounted();
	 if (ExtCountedBars<0) return(0);
	 
	 int limit=Bars;
	
     int i;
	 
	 
	  for( i=limit-1; i>=0; i--)
	   {
	   
	   VOL[i]= Volume[i];
	   }
	 
	
	   for( i=limit-1; i>=0; i--)
	   {
	        if (Close[i]>Close[i+1])
			{
			VP[i]=Volume[i];
			}
			else
			{
			VP[i]=-Volume[i];
			}			
	  } 
	  
	     for( i=limit-1; i>=0; i--)
	   {
	   
	     VPA[i] = iMAOnArray(VP,0,Period1,0,1,i);
	       
	  } 
	  
	     for( i=limit-1; i>=0; i--)
	   {
	   
	    VA[i] = iMAOnArray(VOL,0,Period1,0,1,i);
	       
	  } 
	  
	  
	  
  
	   for(i=limit-Period1*2 ; i>=0; i--)
	    {	  
		if (VA[i]!=0)	VZO[i]=iSsm((VPA[i]/VA[i])*100,smooth,i);
		
		}
		
		  int windowIndex=WindowFind("VZO");
         // finding the window number of our indicator
   
   if(windowIndex<0)
   {
      // if the number is -1, there is an error
      Print("Can\'t find window");
      return(0);
   }  
		
	
 

 return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double workSsm[][2];
#define _tprice 0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

double iSsm(double tprice, double period, int i, int instanceNo=0)
{
   if (period<=1) return(tprice); i = Bars-i-1;
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
          workSsm[i][s+_tprice] = tprice;
          workSsm[i][s+_ssm]    = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                  workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                  workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
   return(workSsm[i][s+_ssm]);
}